/*
  SDL_Audiolib - An audio mixing, decoding and resampling library
  Copyright (C) 2013  Nikos Chantziaras

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
#ifndef AM_UTIL_H
#define AM_UTIL_H

#ifdef AULIB_DEBUG
    #include <cassert>
    #include <iostream>
    #define AM_debugAssert assert
    #define AM_debugPrint(x) std::cerr << x
    #define AM_debugPrintLn(x) AM_debugPrint(x) << '\n'
#else
    #define AM_debugAssert(x)
    #define AM_debugPrintLn(x)
    #define AM_debugPrint(x)
#endif

#include "aulib_export.h"

/* We use these C++11 keywords in our code. We provide appropriate definitions
 * for them on non-C++11 compilers. */
#if __cplusplus < 201103L
    #define override
    #define final
    #define constexpr
    #define nullptr NULL
#endif

#endif
