/*
  SDL_Audiolib - An audio mixing, decoding and resampling library
  Copyright (C) 2013  Nikos Chantziaras

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
#ifndef AUDIODECODER_H
#define AUDIODECODER_H

#include "am_util.h"
#include <SDL_stdinc.h>

struct SDL_RWops;

namespace Aulib {

class AULIB_EXPORT AudioDecoder {
public:
    AudioDecoder();
    virtual ~AudioDecoder();

    virtual int open(SDL_RWops* rwops) = 0;
    virtual void getSpec(unsigned& channels, unsigned& rate) = 0;
    virtual int decode(float buf[], int len, bool& callAgain) = 0;
    virtual int rewind() = 0;
    virtual Sint64 lengthMs() const = 0;

private:
    AudioDecoder(const AudioDecoder&);
    AudioDecoder& operator =(const AudioDecoder&);
};

} // namespace Aulib

#endif
