/*
  SDL_Audiolib - An audio mixing, decoding and resampling library
  Copyright (C) 2013  Nikos Chantziaras

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
#ifdef AULIB_MPG123
#ifndef DEC_MPG123_H
#define DEC_MPG123_H

#include "audiodecoder.h"

namespace Aulib {

class AULIB_EXPORT AudioDecoderMpg123: public AudioDecoder {
public:
    AudioDecoderMpg123();
    ~AudioDecoderMpg123() override;

    int open(SDL_RWops* rwops) override;
    void getSpec(unsigned& channels, unsigned& rate) override;
    int decode(float buf[], int len, bool& callAgain) override;
    int rewind() override;
    Sint64 lengthMs() const override;

private:
    class AudioDecoderMpg123_priv* d;
};

} // namespace Aulib

#endif
#endif
