/*
  SDL_Audiolib - An audio mixing, decoding and resampling library
  Copyright (C) 2013  Nikos Chantziaras

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
#ifdef AULIB_SRC
#ifndef RESAMP_SRC_H
#define RESAMP_SRC_H

#include "audioresampler.h"

namespace Aulib {

class AULIB_EXPORT AudioResamplerSRC: public AudioResampler {
public:
    AudioResamplerSRC();
    ~AudioResamplerSRC() override;

protected:
    int doResampling(float dst[], const float src[], int& dstLen,
                     int& srcLen) override;

    int adjustForOutputSpec(unsigned dstRate, unsigned srcRate,
                            unsigned channels) override;

private:
    class AudioResamplerSRC_priv* d;
};

} // namespace Aulib

#endif
#endif
