/*
  SDL_Audiolib - An audio mixing, decoding and resampling library
  Copyright (C) 2013  Nikos Chantziaras

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
#include "stream.h"

using Aulib::Stream;


class Aulib::Stream_priv {
    friend class Stream;

    Stream_priv();
    ~Stream_priv();

    Stream::FinishCallback fFinishCallback;
    Stream::LoopCallback fLoopCallback;
};


Aulib::Stream_priv::Stream_priv()
{
}


Aulib::Stream_priv::~Stream_priv()
{
}


Stream::Stream()
    : d(new Stream_priv)
{
}


Stream::~Stream()
{
    delete d;
}


void
Stream::setFinishCallback(FinishCallback func)
{
    d->fFinishCallback = func;
}


void
Stream::unsetFinishCallback()
{
    d->fFinishCallback.clear();
}


void
Stream::setLoopCallback(Stream::LoopCallback func)
{
    d->fLoopCallback = func;
}


void
Stream::unsetLoopCallback()
{
    d->fLoopCallback.clear();
}


void
Stream::invokeFinishCallback()
{
    if (d->fFinishCallback) {
        d->fFinishCallback(*this);
    }
}


void
Stream::invokeLoopCallback()
{
    if (d->fLoopCallback) {
        d->fLoopCallback(*this);
    }
}
